16.5.0 (2025-06-13)
	- This version includes security fixes, please update ASAP.
	- Please update the code in your shared/config/tce_config.php file with the latest one.
	- The tcecode parser was updated to sanitize input and avoid XSS.

16.3.7 (2025-01-26)
	- Updated TCPDF.

16.3.6 (2024-12-24)
	- Updated TCPDF.

16.3.5 (2024-12-13)
	- Replace utf8_encode() with mb_convert_encoding().

16.3.4 (2024-12-13)
	- Patched security issues.
	- Updated TCPDF.

16.3.1 (2024-03-24)
	- Updated documentation and licensing information.
	- Updated TCPDF.
	- Format code.
	- Requires PHP 8.0+
	- Minor fixes.
	- Updated Spanish translation.

15.0.0 (2022-12-17)
	- Updated database tce_tests.test_repeatable column to support numeric values.
	- Test repeatability can now be limited to a fixed value.

14.9.0 (2022-12-17)
	- Support for custom authentication methods.

14.8.6 (2022-12-17)
	- Update TCPDF library.

14.8.5 (2021-08-05)
	- Security patches.

14.5.0 (2020-12-30)
	- New custom mobile theme.

14.3.0 (2020-06-12)
	- Various security fixes.

14.0.0 (2017-04-22)
	- Change password hashing algorithm.
	- NOTE: all passwords have to be reset!

13.3.0 (2016-09-06)
	- Fix undefined K_USRREG_PASSWORD_RE issue.

13.2.1 (2016-08-22)
	- Fix fatal error in tce_db_dal.php.

13.2.0 (2016-08-21)
	- The K_USRREG_PASSWORD_RE constant was added in shared/config/tce_user_registration.php to set the regular expression used to filter input passwords.
	- An error with the C_mailer class was fixed.
	- Automatic code formatting.

13.1.1 (2016-03-15)
	- Fix a critical bug introcuced in version 13.0.0 that prevent storing the correct answers.

13.0.1 (2015-12-12)
	- Fix a bug related to PDF email attachments.

13.0.0 (2015-12-12)
	- Hide internal answer IDs during test execution.

12.2.6 (2015-10-26)
	- README in markdown format.
	- Updated license terms.

12.2.5 (2015-06-18)
	- TCPDF Library was updated.
	- German translation was updated.

12.2.4 (2015-04-29)
	- TCPDF Library was updated.

12.2.3 (2015-04-28)
	- TCPDF Library was updated.

12.2.2 (2015-03-29)
	- LDAP Authentication bug was fixed.

12.2.1 (2015-03-27)
	- Do not check for brute-forcing login attempts if K_BRUTE_FORCE_DELAY_RATIO is set to zero.
	- The LDAP config now contains 2 new settings for the root DN and password used during binding.
	- A LDAP authentication bug was fixed.

12.1.30 (2015-01-28)
	- TCPDF library was updated.

12.1.29 (2014-12-10)
	- TCPDF library was updated.

12.1.28 (2014-12-09)
	- TCPDF library was updated.

12.1.027 (2014-12-07)
	- TCPDF library was updated.

12.1.026 (2014-11-15)
	- TCPDF library was updated.

12.1.025 (2014-11-08)
	- TCPDF library and fonts were updated.

12.1.024 (2014-06-11)
	- An unused paramer was removed.
	- OMR scan was improved.
	- TCPDF library was updated.

12.1.023 (2014-05-14)
	- Some language typos were fixed.

12.1.022 (2014-05-12)
	- TCPDF library and fonts were updated.

12.1.021 (2014-04-27)
	- Deprecated curly braces substring syntax was replaced with square braces.
	- TCPDF library was updated.

12.1.020 (2014-04-15)
	- TCPDF library was updated.

12.1.019 (2014-03-24)
	- Emulating magic_quotes_gpc for PHP 5.5 compatibility.

12.1.018 (2014-03-04)
	- New Farsi (Persian) language translation.
	- Some LTR direction settings were fixed.

12.1.017 (2014-03-02)
	- The unhtmlentities function was changed for performances and PHP 5.5 compatibility.
	- TCPDF library was updated.

12.1.016 (2014-01-27)
	- Statistics options are now enforced also in various export formats.

12.1.015 (2014-01-26)
	- A bug on session function was fixed.
	- A bug on mysql error reporting was fixed.

12.1.014 (2014-01-23)
	- Test user time was fixed in public reports.

12.1.013 (2014-01-21)
	- Test Results Summary was improved: some statistics are now disabled by default to improve performances.
	- TSV export for results was fixed.
	- File media selector bug was fixed.
	- TCPDF library was updated.

12.1.012 (2013-12-24)
	- MathML is now supported via the [mathml] tag. Note that is not yet possible to export the formulas in PDF format.

12.1.011 (2013-12-11)
	- A problem related to custom error messages and TCPDF library was fixed.

12.1.010 (2013-12-01)
	- TCPDF library was updated.

12.1.009 (2013-10-24)
	- Bug fix related to the new F_escape_sql function signature.

12.1.008 (2013-10-23)
	- The signature of the F_escape_sql function was changed to add the database link identifier.
	- The MySQL Database Abstraction Layer now uses the MySQLi extension by default (you can set the 'K_DATABASE_TYPE' constant to 'MYSQLDEPRECATED' to use the old extension). 
	- TCPDF Library was updated.

12.1.007 (2013-09-14)
	- TCPDF Library was updated.

12.1.006 (2013-09-05)
	- New JSON export format.
	- TSV report now includes the details for each user.

12.1.005 (2013-08-23)
	- Support for 0-difficulty questions was added.

12.1.004 (2013-08-07)
	- A problem with email reports was fixed.

12.1.003 (2013-08-05)
	- TCPDF Library was updated.

12.1.002 (2013-07-16)
	- Missing SQL files were added - please ugrade your existing DB.

12.1.001 (2013-07-14)
	- A problem related to SVG graphs on PDF export was fixed.

12.1.000 (2013-07-10)
	- IMPORTANT: the database schema is changed please use the upgrading SQL files in case of upgrade.
	- This version includes a new feature that allows to restrict test access based on client SSL certificate.
	- It is now possible to restrict the admin and/or public area access only to clients with valid SSL certificate (check the new options on the admin and public configuration files).
	- TCPDF Library was updated.

------------------------------------------------------------


12.0.014 (2013-05-31)
	- TCPDF library was updated.
	- An additional ordering option for questions was added on the test editor.

12.0.013 (2013-05-21)
	- TCPDF library was updated.
	- An error on a SQL query when importing OMR answers was fixed.
	- An option was added to overwrite non-repeatable test answers when importing via OMR.

12.0.012 (2013-05-02)
	- The constant K_USER_GROUP_RSYNC was added on the configuration file /shared/config/tce_config.php to enable or disable the the users groups synchronization when an alternate authentication method is used.

12.0.011 (2013-04-25)
	- OMR import was improved : MCSA with multiple answers are now set as unanswered.

12.0.010 (2013-04-22)
	- Latex rendering class was removed and replaced with a new function.
	- phpCAS class was updated.

12.0.009 (2013-04-15)
	- TCExam project was moved to GitHub: https://github.com/tecnickcom/tcexam/

12.0.008 (2013-04-12)
	- A bug on test selection form was fixed.
	- Default permissions for file manager were lowered to the operator level.
	- Non-administrators may now access to their cache folder or the ones of the users in their groups.
	- Some bugs on TSV question importer were fixed.

12.0.007 (2013-04-09)
	- Automatic "onchange" update on Test Results Summary form was disabled - now you have to press the select button to update results.
	- Test selection queries were fixed for postgresql.
	- OMR page generation was fixed for some languages.
	- New config.default configuration directories were added on admin, public and shared folders to avoid overriding the existing configuration files during "git pull".

12.0.006 (2013-04-08)
	- Fixing some SQL queries and result values.

12.0.005 (2013-04-05)
	- Some SQL queries were fixed for PostgreSQL compatibility.
	- TCPDF Library was updated.

12.0.004 (2013-04-03)
	- The ordering modes for answers were fixed.
	- A bug on form fields format check was fixed.
	- TCPDF Library was updated.

12.0.003 (2013-04-02)
	- Date field input fields are now correctly aligned.
	- TCPDF Library was updated.

12.0.002 (2013-04-02)
	- A problem related to MySQL and boolna values was fixed.
	- TCPDF Library was updated.

12.0.001 (2013-03-31)
	- Some RTL language problems were fixed.
	- TCPDF Library was updated.

12.0.000 (2013-03-17)
	- IMPORTANT: the database schema is changed.
	- Constant K_OTP_LOGIN was added to shared/config/tce_config.php to enable One-Time-Password.
	- Constant K_LOGOUT_URL was added to shared/config/tce_config.php to customize redirect link after logout.
	- SSL certificate login support.
	- All test statistics were merged on a single page with more information: tests > results.
	- Test statistics are now also available on the public page.
	- The SVG statistic graph is now exported on PDF.
	- Ordering mode options were added on test editor.
	- A password-specific test feature was added on test editor.
	- Some problems on test editor were fixed.
	- A selector page and popup for tests was added.
	- The history of repeated tests is now preserved.
	- Performances of test generation were improved.
	- Some authorization/permission problems were fixed.
	- "font" and "size" tags were added on tcecode to set the font family and size.
	- A virtual keyboard was added on some textarea fields.
	- Navigation buttons on the public interface now reports the number of questions.
	- Questions can be exported and imported using a tab-separated values format (TSV).
	- All CSV formats were changed to TSV (tab-separated-values).
	- Local autosave was added for free answers (only supported by newer web browsers).
	- Some files were renamed.
	- TCPDF Library was updated to version 6 and moved to another folder.

------------------------------------------------------------

11.4.002 (2012-11-14)
	- Constant K_MYSQL_QA_BIN_UNIQUITY was moved to admin/config/tce_config.php
	- Constant K_UTF8_NORMALIZATION_MODE was added to admin/config/tce_config.php to set the UTF-8 normalization mode for question and answer descriptions.
	- The TCPDF library was updated.

11.4.001 (2012-11-07)
	- The MySQL collation for the questions and answer was reverted to utf8_unicode to respect natural ordering.
	- Constant K_MYSQL_QA_BIN_UNIQUITY was added on configuration file to check the unicity of question and answer descriptions using utf8_bin collation when using MySQL.
	- To normalize questions and answer unicode representation, please install php5-intl extension for php.
	- The TCPDF library was updated.

11.4.000 (2012-11-06)
	- The MySQL collation for the questions and answer fields was changed to utf8_bin.
	- The TCPDF library was updated.
	- Hungarian translation was updated.

11.3.012 (2012-09-14)
	- The module for alternative authentication methods was fixed.
	- The TCPDF library was updated.

11.3.011 (2012-09-07)
	- The module for alternative authentication methods was improved to automatically sync the user groups.
	- The TCPDF library was updated.

11.3.010 (2012-09-07)
	- The module for alternative authentication methods was improved to accept multiple default groups (comma separated group IDs, or 0 for all groups).
	- The TCPDF library was updated.

11.3.009 (2012-08-22)
	- A security vulnerability problem was fixed (thanks to High-Tech Bridge Security Research Lab - https://www.htbridge.com/advisory/ ).
	- The TCPDF library was updated.

11.3.008 (2012-08-08)
	- A security vulnerability problem was fixed on tce_edit_answer.php and tce_edit_question.php (thanks to Chris Cooper - Reaction Information Security - www.reactionis.co.uk).
	- The TCPDF library was updated.

11.3.007 (2012-08-02)
	- Arabic language was updated.
	- The TCPDF library was updated.

11.3.006 (2012-08-01)
	- OMR bulk importer now creates a log file on the cache folder.

11.3.005 (2012-07-31)
	- A bulk importer for OMR data was added.
	- OMR import algorithm waas fixed and improved.

11.3.004 (2012-07-26)
	- The TCPDF library was updated.

11.3.003 (2012-07-25)
	- CSS files were updated.
	- The TCPDF library was updated.

11.3.002 (2012-07-25)
	- The TCPDF library was updated.
	- A problem related to the QRCode size on offline PDF test was fixed.

11.3.001 (2012-07-23)
	- On Test Editor is now possible to select all type of questions at once.
	- The favicon.ico file was updated.
	- The TCPDF library was updated.

11.3.000 (2012-06-07)
	- The encryption algorithm for passwords was improved and is NOT compatible with the old method.
	- If you are upgrading and you do not want to manually reset all passwords, set the K_STRONG_PASSWORD_ENCRYPTION constant to FALSE on shared/config/tce_config.php
	- The default password for admin is 1234 and the correspondent encoding is on install/dbdata.sql file.
	- TCPDF Library was updated.

------------------------------------------------------------

11.2.032 (2012-06-06)
	- TCPDF Library was updated to fix a bug introduced on the previous version.

11.2.031 (2012-06-05)
	- Support for external authentication systems were improved.
	- TCPDF Library was updated.

11.2.030 (2012-04-30)
	- Romanian Language was updated.
	- TCPDF Library was updated.

11.2.029 (2012-04-27)
	- A "division by zero" bug was fixed.

11.2.028 (2012-04-25)
	- TCPDF library was updated.
	- Arabic Language was updated.

11.2.027 (2012-04-19)
	- TCPDF library was updated.
	- Division by zero problem was fixed on tce_show_allresults_users.php
	- A user selection/search popup utility was added (click on the [...] button next to each user select box).
	- Constant K_PASSWORD_RESET was added on shared/config/tce_config.php to enable password reset feature.
	- A "Password Reset" feature was added on login page.
	- An SVG graph was added on User's Results page.

11.2.026 (2012-04-02)
	- TCPDF library was updated.
	- Font files were updated.

11.2.025 (2012-03-28)
	- TCPDF library was updated.
	- Font files were updated.

11.2.024 (2012-03-19)
	- Hidden answers on PDF tests now support multiple lines.
	- TCPDF library was updated.

11.2.023 (2012-01-30)
	- Brazilian language was updated.
	- TCPDF library was updated.

11.2.022 (2012-01-23)
	- A problem with generation of multiple offline tests on PDF was fixed.
	- Test Editor has been changed so a test can be also assigned to groups that do not belongs to the author's groups.

11.2.021 (2011-12-23)
	- Source code documentation was updated.

11.2.020 (2011-12-14)
	- Chinese language was updated.

11.2.019 (2011-12-14)
	- TCPDF library was updated.

11.2.018 (2011-12-13)
	- A bug on tce_show_allresults_users.php file was fixed.
	- TCPDF library was updated.

11.2.017 (2011-11-15)
	- Some problems with chinese language were fixed.
	- Chinese translation was updated.
	- TCPDF library was updated.

11.2.016 (2011-10-29)
	- Some authentication/sessions problems were fixed.
	- TCPDF library was updated.

11.2.015 (2011-10-12)
	- TCPDF library and fonts was updated.

11.2.014 (2011-09-14)
	- Some edit forms on administration area were changed to display the [add] button only when the first empty profile (+) is selected.
	- All edit forms on the administration area now includes a checkbox next to the update button that must be selected in order to confirm the update.
	- TCPDF library was updated.

11.2.013 (2011-08-06)
	- Spanish language was updated.
	- TCPDF library was updated.

11.2.012 (2011-07-13)
	- IMPORTANT: This version includes some security fixes. Thanks to Gjoko Krstic, Zero Science Lab (http://www.zeroscience.mk) for testing and reporting.
	- TCPDF library was updated.

11.2.011 (2011-07-12)
	- IMPORTANT: This version includes some security fixes. Thanks to Gjoko Krstic, Zero Science Lab (http://www.zeroscience.mk) for testing and reporting.
	- Azerbaijani language was added.

11.2.010 (2011-06-28)
	- Arabic language was updated.
	- TCPDF library was updated.

11.2.009 (2011-06-28)
	- OMR system (offline testing) was improved.
	- TCPDF library was updated for improvements and bugfixes.
	- Romanian language was updated.

11.2.008 (2011-06-18)
	- TCPDF library was updated for improvements and bugfixes.

11.2.007 (2011-06-15)
	- TCPDF library was updated for improvements and bugfixes.

11.2.006 (2011-06-14)
	- TCPDF library was updated for improvements and bugfixes.

11.2.005 (2011-05-31)
	- TCPDF library was updated to fix a font subsetting bug.
	- Font files were updated.

11.2.004 (2011-05-26)
	- Question Importer was fixed to correctly import questions and answers positions.

11.2.003 (2011-05-24)
	- XML question exporter was fixed to correctly set the keyboard keys.
	- Selection filters were fixed for PDF, TSV and XML export.

11.2.002 (2011-05-22)
	- A problem with magic_quotes_gpc was fixed.

11.2.001 (2011-05-21)
	- Some security vulnerabilities were fixed.

11.2.000 (2011-05-21)
	- TCExam now includes Optical Mark Recognition (OMR) system to import users' answers from paper sheets (requires ImageMagick, zlib extensions and zbarimg application http://zbar.sourceforge.net/).
	- The [generate] button next to "PDF offline test" field on Test Management page now creates extra pages for offline testing with special answer sheets.
	- The constant K_OMR_PATH_ZBARIMG was added to /admin/config/tce_config.php configuration file to set the path to zbarimg application required for OMR feature.
	- The /admin/config/tce_auth.php configuration file was updated to include new constants.
	- Labels of TSV export were fixed.
	- Minor bugs were fixed.
	- TCPDF library was updated.

------------------------------------------------------------

11.1.031 (2011-05-06)
	- A bug related question XML exporter was fixed (on your exported XML questions files you have to replace "key>" with "keyboard_key>").
	- Test and User results interfaces and export filters (XML, TSV, PDF) were improved.
	- TCPDF library was updated.

11.1.030 (2011-05-04)
	- A bug related to alternative login modes were fixed.
	- A problem related to 'latex' and 'code' buttons on questions editor was fixed.
	- A fix for get_magic_quotes_gpc turned off was added (shared/config/tce_config.php was updated).
	- TCPDF library was updated.

11.1.029 (2011-04-26)
	- Arabic language was updated.
	- TCPDF library was updated.

11.1.028 (2011-04-10)
	- TCPDF performances were improved.

11.1.027 (2011-04-07)
	- Bulgarian language was updated.
	- TCPDF library was updated.

11.1.026 (2011-03-15)
	- Some Accessibility problems were fixed.
	- TCPDF library was updated.

11.1.025 (2011-03-14)
	- "Reflected Cross-site Scripting" security problem was fixed.

11.1.024 (2011-03-08)
	- Login problems were fixed. Please check the new default values of K_CHECK_SESSION_FINGERPRINT and K_REDIRECT_LOGIN_MODE con shared/config/tce_config.php

11.1.023 (2011-03-05)
	- Problem of downloading backups with IE8 was fixed.

11.1.022 (2011-02-27)
	- Bug #3193785 "Free text field writing error" was fixed.
	- TCPDF library was updated.

11.1.021 (2011-02-22)
	- Romanian language was updated.
	- TCPDF library was updated to fix automatic line break problem.

11.1.020 (2011-02-21)
	- Question Import module was fixed for missing module owner field.
	- The owner of a module can now be changed by administrator.
	- Checks on Topic owner were removed in favor of module owner.

11.1.019 (2011-02-15)
	- TCPDF library was updated to fix line break problem.

11.1.018 (2011-02-09)
	- A bug related to K_MAX_ROWS_PER_PAGE constant set to zero was fixed.
	- A bug related to UTF8 substrings was fixed.
	- Several bugs related to empty data were fixed.

11.1.017 (2011-02-02)
	- Sessions were fixed for improved compatibility with php.ini settings.
	- The K_REDIRECT_LOGIN_MODE constant value was changed to 4 on shared/config/tce_config.php (change this walue if you have login problems).

11.1.016 (2011-01-28)
	- Hungarian language was updated.
	- TCPDF library was updated.
	- IMPORTANT: postgreSQL and MySQL schema were changed to drop ak_question and ak_answer indexes.

11.1.015 (2011-01-20)
	- Scrollbars were added on object window.
	- TCPDF library was updated.

11.1.014 (2011-01-15)
	- TCPDF library and Arabic language were updated.

11.1.013 (2011-01-02)
	- A problem with [generate] button on tce_edit_test.php file was fixed.

11.1.012 (2010-12-19)
	- Bug item #3140294 "Question move" was fixed.
	- Fonts for PDF documents were updated.
	- TCPDF library was updated.

11.1.011 (2010-12-18)
	- A problem with public PDF documents was fixed.
	- Several source code documentation errors were fixed.
	- Source code style was changed for Doxygen.
	- Source code documentation was moved online to http://www.tcexam.org

11.1.010 (2010-12-06)
	- Chinese translation was updated.
	- TCPDF library was updated.
	- File shared/code/tcpdfex.php was added to set custom header/footer on PDF pages.
	- QR-Codes are now printed by default on PDF headers to link back the TCExam web pages.

11.1.009 (2010-11-26)
	- Bulgarian translation was updated.
	- TCPDF library was updated.

11.1.008 (2010-11-21)
	- A problem related to sending PDF via email was fixed.
	- TCPDF library was updated.

11.1.007 (2010-11-19)
	- Chinese language was updated.
	- TCPDF library was updated.

11.1.006 (2010-11-17)
	- Bug item #3110771 "Undefined variable: user_id" was fixed.
	- Language file was updated.
	- TCPDF library was updated.

11.1.005 (2010-10-21)
	- On this version the PDF text direction was improved to include the case of RTL text on LTR direction and LTR text on RTL direction.
	- The tag [dir] and relative buttons were added to fix content direction for PDF ltr=left-to-right, rtl=right-to-left.

11.1.004 (2010-10-21)
	- The constant K_CHECK_SESSION_FINGERPRINT was added to /shared/config/tce_config.php to check for possible session hijacking (set to false if you have login problems).
	- TCPDF library was updated to fix alignment problems with RTL languages.

11.1.003 (2010-10-06)
	- The security and reliability of user sessions was improved.
	- A minor bug was fixed on shared/code/tce_functions_test.php
	- Clock-Timer was changed to display server time.
	- Several files were changed to limit the permissions of non-administrators to their own groups and users with lower level.
	- Several constants were added on /admin/config/tce_auth.php to fine tune permissions.
	- Some translations were updated.
	- TCPDF library was updated.

11.1.002 (2010-09-26)
	- Public test list was improved (shared/code/tce_functions_test.php).
	- The constant K_HIDE_EXPIRED_TESTS was added to public/config/tce_config.php to control the display of expired tests on public page.
	- TCPDF library was updated.

11.1.001 (2010-09-23)
	- The security of sessions has been improved.

11.1.000 (2010-09-22)
	- Web menu was added on public area.
	- Users can now change email and password form public area.
	- Public test list was improved.
	- Media File Manager was added on administration area.
	- HTTP Basic Authentication was added. Check the new shared/config/tce_httpbasic.php configuration file.
	- Configurations files now contains new options.
	- A new /public/config/tce_auth.php configuration file was added to change the permission levels for public area.
	- The "explanation" area on "Question Management" and "Multiple-Answer Management" is now collapsed by default.
	- Question and Answer Management was simplified.
	- Some compatibility issues were fixed.
	- TCPDF library was updated.

------------------------------------------------------------

11.0.016 (2010-09-07)
	- Automatic uppercase was removed from main menu for UTF-8 compatibility.

11.0.015 (2010-09-05)
	- Administration menu system was improved.
	- Minor improvements.

11.0.014 (2010-09-03)
	- TCPDF library was updated.

11.0.013 (2010-08-18)
	- A minor bug on User Selection page was fixed.
	- TCPDF library was updated.

11.0.012 (2010-08-17)
	- Test management page now include questions statistics for each topic: [ (number of questions)(question type S,M,T,O)(difficulty):(min answers)-(max-answers) ].
	- TCPDF library was updated.

11.0.011 (2010-08-14)
	- TCPDF library was updated.

11.0.010 (2010-08-13)
	- Method F_decode_form_fields() was fixed.
	- TCPDF library was updated.

11.0.009 (2010-08-09)
	- PHP end tags were removed from end-of-file.
	- TCPDF library was updated.

11.0.008 (2010-07-31)
	- TCPDF library was updated.

11.0.007 (2010-07-14)
	- tce_edit_backup was fixed for special characters.
	- TCPDF library was updated.

11.0.006 (2010-07-12)
	- TCPDF library was updated.

11.0.005 (2010-06-29)
	- Hungarian language was updated.
	- TCPDF library was updated.

11.0.004 (2010-06-24)
	- Brazilian and Romanian language was updated.
	- TCPDF library was updated (several syntax errors and compatibility problems were corrected).

11.0.003 (2010-06-19)
	- Arabic language was updated.
	- TCPDF library was updated.

11.0.002 (2010-06-18)
	- TCPDF library was updated.

11.0.001 (2010-06-18)
	- TCPDF library was updated.

11.0.000 (2010-06-18)
	- Database schema is changed.
	- Group authentication restrictions were added to the modules. Now, except for the administrator, the modules and relative subjects can be edited only by members of the same group of the module author.
	- Some constants were added to the configuration files /admin/config/tce_auth.php and /admin/config/tce_config.php.
	- A button to download backup files was added to Database Backup and Restore.
	- TCPDF library was updated.

------------------------------------------------------------

10.1.012 (2010-06-13)
	- THIS VERSION CONTAINS A SECURITY FIX.

10.1.011 (2010-06-12)
	- THIS VERSION CONTAINS A SECURITY FIX.
	- Now you can upload only the file types listed on K_ALLOWED_UPLOAD_EXTENSIONS constant at admin/config/tce_config.php.

10.1.010 (2010-06-10)
	- MIME configuration file was updated to include MP4 video type.

10.1.009 (2010-06-09)
	- TCPDF library was updated.

10.1.008 (2010-06-07)
	- TCPDF library was updated (now uses font subsetting by default).

10.1.007 (2010-05-28)
	- A button to lock/unlock a test was added on Test Management.
	- Remaining user's time information was added on Test Results Summary.
	- Arabic language was updated.
	- TCPDF library was updated.

10.1.006 (2010-05-21)
	- TCPDF library was updated.

10.1.005 (2010-05-19)
	- TCPDF library was updated.

10.1.004 (2010-05-19)
	- Source code documentation was fixed.
	- TCPDF library was updated.

10.1.003 (2010-05-19)
	- TCPDF library was updated.

10.1.002 (2010-05-12)
	- Time descriptions on general PDF report were fixed.
	- TCPDF library was updated.

10.1.001 (2010-05-10)
	- TCPDF library was updated.

10.1.000 (2010-05-10)
	- Selection menu was moved on the top of the page.
	- XML exporter was added for Question Statistics.
	- Bug #2998891 "In xml file malformed text-answers" was fixed.
	- Some language translations were updated.
	- TCPDF library was updated.

------------------------------------------------------------

10.0.013 (2010-04-07)
	- TCPDF library was updated.

10.0.012 (2010-04-05)
	- TCPDF library was updated.

10.0.011 (2010-04-05)
	- TCPDF library was updated.

10.0.010 (2010-03-31)
	- TCPDF library was updated.
	- User registration email mail functions were fixed to support SSL.
	- Offline test generator now avoids page splitting of questions or answers.

10.0.009 (2010-03-10)
	- phpMailer library was updated.
	- Language files were updated.
	- TCPDF library was updated.
	- A minor javascript bug was fixed.

10.0.008 (2010-02-26)
	- Language files were updated.

10.0.007 (2010-02-24)
	- Language files were updated.
	- TCPDF library was updated.

10.0.006 (2010-02-20)
	- A warning message showing omitted questions is now displayed when the test termination button is pressed.
	- Language files were updated.

10.0.005 (2010-02-19)
	- Bug item #2954840 "Error in preparing the PDF data" was fixed.

10.0.004 (2010-02-19)
	- Question statistics were fixed.
	- Language files were updated.

10.0.003 (2010-02-17)
	- Some deprecated functions for PHP 5.3 were replaced.

10.0.002 (2010-02-17)
	- A timer/clock bug was fixed.
	- Topics results were added on PDF user results.
	- Test is now automatically terminated if the navigation menu is hidden and the last question is timed or auto-next.
	- Language files were updated.
	- UPGRADE.TXT instructions were updated.

10.0.001 (2010-02-12)
	- Missing update was added.

10.0.000 (2010-02-12)
	- THIS IS A MAJOR RELEASE.
	- Database schema is changed (see documentation on admin/doc/database).
	- An option to avoid partial scoring for MCMA questions was added on Test Editor.
	- An option to avoid logout when the time expires was added on Test Editor.
	- A Database Backup and Restore page was added (works only on POSIX systems with MySQL or PostgreSQL).
	- Constant K_PATH_BACKUP was added on shared/config/tce_paths.php
	- Question statistics were improved.
	- TCPDF library was updated.
	- Language files were updated.

--------------------------------------------------------------------------------

9.0.041 (2010-02-06)
	- Test description is now displayed before test execution (check the new K_DISPLAY_TEST_DESCRIPTION constant on shared/config/tce_config.php).
	- TCPDF library was updated.

9.0.040 (2010-01-30)
	- TCPDF library was updated for better RTL support.

9.0.039 (2010-01-15)
	- TCPDF library was updated.

9.0.038 (2010-01-15)
	- Sessions ID problem was fixed.
	- TCPDF library was updated.

9.0.037 (2009-12-31)
	- The "hide answers" options now works with PDF Questions List.
	- The Results pages now includes the ability to send results via email with or without PDF report.
	- TCPDF library was updated.

9.0.036 (2009-12-15)
	- Per-topic results were added on Test Results page.
	- Answer Evaluation form was updated to order answers in various modes.
	- TCPDF library was updated.
	- Installation instructions were updated.
	- Hungarian language was updated.

9.0.035 (2009-11-10)
	- Source code documentation was fixed.

9.0.034 (2009-11-05)
	- The $emailcfg['SMTPSecure'] parameter was added to /gshared/config/cp_email_config.php file.
	- The file tce_functions_email_reports.php was changed to include the SMTPSecure parameter.

9.0.033 (2009-11-03)
	- IP addresses representation was fixed.

9.0.032 (2009-10-24)
	- LaTeX caching bug was fixed.

9.0.031 (2009-10-23)
	- TCPDF library was updated.

9.0.030 (2009-10-22)
	- License terms were changed to AGPLv3 (read the LICENSE.TXT file for more information).
	- TCPDF library was updated.

--------------------------------------------------------------------------------

9.0.029 (2009-10-09)
	- Support for ORACLE database was added (via oci8 PHP extension).

9.0.028 (2009-10-07)
	- The problem of fixed ordered answers on MCSA questions in PDF test preview was fixed (tce_pdf_testgen).
	- Search feature was added to "User Selection" form.
	- Links to "User's Results" were added on "User Selection" form.
	- Image / object selection was improved (now support subfolders and alphabetic ordering).
	- The cache name for latex images was changed (now includes date-time).

9.0.027 (2009-10-05)
	- Compatibility with PHP 5.3 was improved.

9.0.026 (2009-09-30)
	- Compatibility with PHP 5.3 was improved.
	- TCPDF library was updated.
	- Source code was cleaned up.
	- Experimental support for automatic updates was added (only Linux systems with MySQL database and valid account).

9.0.025 (2009-09-21)
	- TCPDF library was updated.
	- Installation instructions were udpdated.

9.0.024 (2009-08-31)
	- Romanian language was added.

9.0.023 (2009-08-30)
	- This version creates digital signatures on PDF documents (see shared/config/tce_pdf.php).
	- TCPDF library was updated.

9.0.022 (2009-08-29)
	- localhost to IP conversion problem was fixed.
	- JavaScript used to catch keycodes was fixed for IE.
	- phpMailer Class was updated to version 5.0.2.
	- TCPDF library was updated.

9.0.021 (2009-08-26)
	- TCPDF library was updated (it was broken on previous release).

9.0.020 (2009-08-17)
	- Font files were updated.
	- TCPDF library was updated.

9.0.019 (2009-07-05)
	- Language files were updated.
	- TCPDF library was updated.

9.0.018 (2009-06-15)
	- Language files were updated.
	- TCPDF library was updated.

9.0.017 (2009-06-11)
	- TCPDF library was updated.

9.0.016 (2009-06-08)
	- tce_show_allresults_users.php was fixed for various errors.

9.0.015 (2009-06-04)
	- TCPDF library was updated.

9.0.014 (2009-06-02)
	- shared/config/tce_mime.php file was updated.
	- The score for a free answer cannot be greater than maximum score for the selected question.
	- Language files were updated.

9.0.013 (2009-05-28)
	- TCPDF library was updated to fix list bullets position for RTL languages.

9.0.012 (2009-05-25)
	- CSS files were updated.
	- TCPDF library was updated.
	- The official Website for TCExam is http://www.tcexam.org

9.0.011 (2009-05-11)
	- Bug related to question explanation appearance on "Answer Evaluation" page was fixed.

9.0.010 (2009-05-07)
	- Question explanation was added on "Answer Evaluation" page.
	- TCPDF library was updated.

9.0.009 (2009-04-29)
	- Question "autonext" and "timer" features were fixed.
	- TCPDF library was updated.

9.0.008 (2009-04-21)
	- TCPDF library was updated.

9.0.007 (2009-04-12)
	- Import functions were fixed.
	- TCPDF library was updated.

9.0.006 (2009-03-27)
	- The class shared/code/tce_txm.php was updated to acquire an exclusive lock on the cache file while proceeding to the writing.
	- The K_PATH_LANG_CACHE constant was added to shared/config/tce_paths.php to define the default folder used for language files. By default the language files are now stored on the new folder: /cache/lang.
	- The file shared/config/tce_config.php was changed to consider the new K_PATH_LANG_CACHE constant.
	- The class phpMailer was updated to version 2.3.
	- The class Radius was updated to version 1.2.2.
	- Installation guide was updated.

9.0.005 (2009-03-26)
	- The English language was updated.
	- index.php redirect was added in the admin and in the public directory.

9.0.004 (2009-03-24)
	- Several minor bugs were fixed on administration interfaces.

9.0.003 (2009-03-24)
	- 'Inserting image' bug was fixed (tce_functions_tcecode_editor.php).

9.0.002 (2009-03-23)
	- Hungarian language was updated.
	- An issue between tce_edit_test.php interface and Opera Web-Browser was fixed.
	- TCPDF library was updated.

9.0.001 (2009-03-18)
	- Arabic language was updated.
	- TCPDF library was updated.

9.0.000 (2009-03-08)
	- THIS IS A MAJOR RELEASE.
	- Database schema is changed (see documentation on admin/doc/database).
	- A new option "repeatable" was added to test, so users can have the ability to repeat the same test several times.
	- "Terminate Test" now redirect user to index page without logging-out.
	- A calendar widget was added to date/time input fields (shared/jscripts/jscalendar).
	- TCPDF was updated.
	- IMPORTANT: translations must be updated to reflect latest changes.

--------------------------------------------------------------------------------

8.0.002 (2009-03-03)
	- Hungarian language was updated.
	- TCPDF was updated.

8.0.001 (2009-02-24)
	- A bug on public interface buttons was fixed.
	- Arabic language was updated.
	- TCPDF was updated.

8.0.000 (2009-02-20)
	- THIS IS A MAJOR RELEASE.
	- Database schema is changed (see documentation on admin/doc/database).
	- Configuration files were changed AND MUST BE REPLACED.
	- New 'explanation' fields were added to questions and answers.
	- CSS files were updated.
	- Minor bugs were fixed.
	- TCPDF was updated.
	- IMPORTANT: translations must be updated to reflect latest changes.

--------------------------------------------------------------------------------

7.1.002 (2009-02-17)
	- Installation scripts were improved.
	- Hungarian language was updated.
	- Source code was cleaned up.

7.1.001 (2009-02-15)
	- Scoring system has been fixed.
	- Bug n.2601919 "Single answer - wrong answer and wrong points" was fixed.

7.1.000 (2009-02-13)
	- CAS authentication module was added (check the /shared/config/tce_cas.php for configuration).
	- All IP addresses are now converted to IPv6 expanded notation (8 4-bytes hexadecimal numbers separate by ':' character).
	- Test editor now accepts IPv6 addresses and ranges, for example: 192.168.*.*,127.0.0.*,192.168.234.16-192.168.234.32,::ffff:c0a8:0110-::ffff:c0a8:0140,2001:0db8:0000:0000:0000:0000:1428:57ab
	- Source code was cleaned up to improve performances.
	- Cached language files were updated.
	- Installation form was improved.
	- TCPDF library was updated.

7.0.029 (2009-02-05)
	- IPv6 support was added. Please ugrade the database using the following SQL queries (by case):

		# --- For MySQL:
		ALTER TABLE tce_users CHANGE user_ip user_ip VARCHAR(39) NOT NULL;
		ALTER TABLE tce_tests_logs CHANGE testlog_user_ip testlog_user_ip VARCHAR(39) NULL DEFAULT NULL;

		# --- For PostgreSQL:
		ALTER TABLE "tce_users" ALTER "user_ip" TYPE Varchar(39);
		ALTER TABLE "tce_tests_logs" ALTER "testlog_user_ip" TYPE Varchar(39);

	- tce_functions_test.php source code was cleaned up.
	- tce_show_result_allusers.php was fixed.
	- tce_functions_user_select.php was fixed.

7.0.028 (2009-01-28)
	- A bug on evaluation of MCSA questions was fixed.
	- Test editor was fixed.
	- Subject editor was fixed.
	- PDF results were fixed.

7.0.027 (2009-01-27)
	- Bug n. 2540741 "Test Management - Wrong number of elements" was fixed.
	- TCPDF library was updated.

7.0.026 (2009-01-26)
	- Update SQL errors on results were fixed.
	- TCPDF library was updated.

7.0.025 (2009-01-24)
	- TCPDF library was fixed.

7.0.024 (2009-01-23)
	- TCPDF library was updated.

7.0.023 (2009-01-23)
	- Several authorization systems were updated or improved.

7.0.022 (2009-01-23)
	- Bug "SQL wrong in tce_functions_auth_sql.php" was fixed.
	- Polish language was added.

7.0.021 (2009-01-21)
	- Spanish language was updated.
	- TCPDF library was updated.

7.0.020 (2009-01-20)
	- Arabic and Hebrew languages were updated.

7.0.019 (2009-01-20)
	- Bugs #2523328 "Modify is forwarding without passing the correct parameters" was fixed.

7.0.018 (2009-01-19)
	- Malay (Bahasa Melayu) language was added.
	- TCPDF library was updated.

7.0.017 (2009-01-13)
	- Some PDF alignments for RTL languages were fixed.

7.0.016 (2009-01-12)
	- TCPDF library was updated.
	- Chinese language was added.

7.0.015 (2008-12-28)
	- TCPDF library was updated.
	- language_tmx.xml was updated (arabic).
	- strtoupper function was removed from several files to improve compatibility with some languages.

7.0.014 (2008-12-26)
	- language_tmx.xml was fixed.

7.0.013 (2008-12-26)
	- New User's Results form were added + export in TSV, XML and PDF.
	- Descriptive statistics were improved and added to PDF and XML.
	- language_tmx.xml contains new terms (please note that all old translations must be checked against new english version).

7.0.012 (2008-12-25)
	- "Test Results Summary" was improved.
	- Descriptive statistics were added on results.
	- language_tmx.xml contains new terms.
	- CSS styles were updated.

7.0.011 (2008-12-23)
	- TCPDF library was updated.

7.0.010 (2008-12-22)
	- Bulgarian language was updated.
	- tce_show_all_questions.php was changed.
	- Questions and Answers ordering was fixed.
	- Questions statistics bug was fixed.

7.0.009 (2008-12-12)
	- TCPDF library and relative fonts were updated.

7.0.008 (2008-12-09)
	- TCPDF bug was fixed.

7.0.007 (2008-12-09)
	- Hebrew language was added.
	- Arabic, Italian and Spanish languages were updated.
	- TCPDF was updated, including fonts and font utils

7.0.006 (2008-12-05)
	- Italian translation was corrected.
	- TCPDF was updated.

7.0.005 (2008-12-04)
	- Import and export functions were fixed.
	- Some translations were updated.
	- TCPDF was updated.

7.0.004 (2008-12-02)
	- Clear button bug was fixed.
	- Source code was cleaned up.

7.0.003 (2008-12-02)
	- Questions ordering was fixed.

7.0.002 (2008-12-02)
	- Installation script was fixed.

7.0.001 (2008-12-01)
	- Bugfixing.

7.0.000 (2008-12-01)
	- THIS IS A MAJOR RELEASE.
	- Database schema is changed (see documentation on admin/doc/database).
	- Configuration files were changed AND MUST BE REPLACED.
	- A new 'Modules' level was added to group topics. The new hierarchy is: module -> topic -> question -> answer.
	- Questions export/import now includes information on topics and modules.
	- Custom question import is now supported by defining admin/code/tce_import_custom.php file.
	- Custom results export is now supported by defining admin/code/tce_export_custom.php file.
	- TCPDF was updated.
	- IMPORTANT: translations must be updated to reflect latest changes.

--------------------------------------------------------------------------------

6.1.000 (2008-11-26)
	- Questions selection was improved: now you can enable, disable, delete or move several questions at the same time.
	- Users selection was improved: now you can delete users or add/delete/move groups.
	- 'Test Results Summary' was improved.
	- A bug related to reaction time recording was fixed.
	- TCPDF was updated.

6.0.004 (2008-11-17)
	- PASSED/NOT-PASSED bug was fixed.
	- PASSED/NOT-PASSED information was added on results pages.
	- F_text_to_xml() function was fixed.
	- XML and CVS headers were fixed.
	- TCPDF was updated.

6.0.003 (2008-11-14)
	- MySQl structure file was changed to add Indexes.
	- A bug relative to multimedia object was fixed.
	- A bug relative to question editor was fixed.
	- Question random selection bug was fixed.
	- TCPDF was updated.

6.0.002 (2008-11-12)
	- A bug relative to PDF fill color on next page was fixed.

6.0.001 (2008-11-12)
	- Hindi language was added.
	- Users' results page was fixed.
	- Question statistics were fixed.
	- TCPDF was updated.

6.0.000 (2008-11-04)
	- THIS IS A MAJOR RELEASE.
	- database schema is changed (see documentation on admin/doc/database).
	- Group filter was added on 'Users Selection' form.
	- The following features were added to the questions:
		* position : to display the questions on the given order.
		* timer: to close automatically the question after the specified amount of seconds.
		* fullscreen: to display the question using the full screen.
	- Several options were added to the Test form:
		* options to set the basic score for right, wrong and unanswered questions (negative values are supported).
		* option to set the required point to pass the exam.
		* independent options to choose if question and answers must be randomly extracted and/or randomly ordered (questions and answers may be displayed on a predefined order).
		* options to enable/disable: test comment, questions menu, no-answer option.
		* option to choose radiobuttons for MCMA questions instead of checkboxes.
		* option to send detailed PDF report to users (reveal correct answers to users).
	- Reaction time stores the milliseconds elapsed between question visualization and user's answer.
	- Option to add a teacher/supervisor comment to the TEXT answers.
	- A bug on F_remove_tcecode() function was removed.
	- TCEcode is now fully compatible with common BBCode.
	- The following tags were added to TCECode: color (text color), bgcolor (background color), u (underline), o (overline), s (strikethrough), size (text size in percentage).
	- A color picker utility was added.
	- the boolean costant K_DISPLAY_PDFTEXT_BUTTON was added to admin/config/tce_config.php to display an additional PDF-TEXT button to print only the TEXT answers on all users' results.
	- Bulgarian language was added.
	- Japanese Language was added.
	- CSS files were updated.
	- TCPDF library was updated.
	- TCPDF default font is now helvetica.
	- Several bugs were fixed.

--------------------------------------------------------------------------------

5.4.006 (2008-09-01)
	- Indonesian language was added.
	- Arabic language was updated.
	- TCPDF was updated.

5.4.005 (2008-08-11)
	- TCPDF was updated.

5.4.004 (2008-08-05)
	- TCPDF was updated.
	- Font utils were updated.

5.4.003 (2008-07-31)
	- TCPDF was updated.

5.4.002 (2008-07-15)
	- German language (DE) was added.
	- Text direction on tce_show_result_questions.php was fixed.
	- TCPDF was updated.
	- CSS files were updated (answers are now listed with numbers instead of letters).

5.4.001 (2008-07-08)
	- Fixed wrong count in PDF questions list.
	- TCPDF was updated.

5.4.000 (2008-07-05)
	- An XML button was added to export the entire test results to XML format.
	- TCPDF library was updated - now includes better support for Arabic and Persian languages.
	- K_PATH_URL was added on /shared/config/tce_paths.php for TCPDF.
	- Arabic language was updated.
	- Bug [2004946] "global $db lost in session_write_close" was fixed.
	- Bug [2010079] "HOWTO LDAP Authentication with Windows 2003 AD Server" was fixed.

5.3.008 (2008-06-04)
	- TCPDF library was updated.

5.3.007 (2008-06-04)
	- TCPDF library was updated.
	- All CSS Files were updated.
	- Page footer was changed.

5.3.006 (2008-05-30)
	- TCPDF library was updated.
	- shared/config/tce_paths.php was updated.

5.3.005 (2008-05-06)
	- User registration form was updated.
	- French language was updated.
	- TCPDF library was updated (Arabic support was fixed).

5.3.004 (2008-04-21)
	- User registration form was updated.
	- TCPDF library was updated.

5.3.003 (2008-04-11)
	- TCPDF library was updated.

5.3.002 (2008-04-11)
	- TCPDF library was updated.
	- Dutch language (NL) was updated.

5.3.001 (2008-04-07)
	- TCPDF library was updated.
	- Dutch language (NL) was added.

5.3.000 (2008-03-28)
	- Software license was changed to GPLv3 (see LICENSE.TXT).
	- TCPDF library was updated.
	- LDAP authentication was added (check the shared/config/tce_ldap.php configuration file).
	- RADIUS support was improved (shared/config/tce_radius.php configuration file was changed).
	- User registration module was added (check the shared/config/tce_user_registration.php configuration file).
	- TMX file contains new translations (search for 5.3.000 comment).

5.2.005 (2008-03-03)
	- TCPDF was updated.

5.2.004 (2008-02-28)
	- TCPDF was updated.
	- tce_pdf_results.php was fixed.
	- TMX language file was fixed.

5.2.003 (2008-02-23)
	- TCPDF was updated.
	- TMX language file was fixed.
	- INSTALL.TXT file was added.
	- Guide files were removed. The guide is now hosted online on http://www.tcexam.org
	- Source code documentation template was changed.
	- Installation form and guide were updated.

5.2.002 (2008-02-10)
	- French language was added.
	- TMX language file was fixed.
	- TCPDF was updated.

5.2.001 (2008-01-27)
	- Arabian language were added
	- K_TCEXAM_STYLE_RTL constant was added to /admin/config/tce_config.php to define a stylesheet for RTL languages.
	- K_SITE_STYLE_RTL constant was added to /public/config/tce_config.php to define a stylesheet for RTL languages.
	- default_rtl.css was added to /admin/styles
	- default_rtl.css was added to /public/styles
	- /admin/tce_edit_answer.php was fixed.
	- tce_preview_tcecode.php was fixed.

5.2.000 (2008-01-14)
	- RADIUS authentication was added. The php_sockets extension must be enabled. Check /shared/tce-radius for configuration.
	- TCPDF was updated.
	- Guide in Marhati language was added.
	- time extension were added to tce_show_result_allusers.php
	- time extension was fixed for MySQL database.
	- K_EXTEND_TIME_MINUTES was added to /shared/config/tce_config.php

5.1.001 (2007-12-27)
	- MCMA bug [1858111] was fixed.

5.1.000 (2007-12-05)
	- Several SQL injection vulnerabilities were fixed.
	- Language selector bug was fixed.

5.0.004 (2007-11-03)
	- The bug relative to questions importing was fixed (tce_import_questions.php).
	- Marathi language was added.
	- Copyright information was updated.
	- "Test Results" interface was improved (tce_show_result_user.php).
	- Administration menu is now dynamic. The elements not accessible to the user are disabled.

5.0.003 (2007-09-16)
	- The Russian language was added.

5.0.002 (2007-09-15)
	- The scoring algorithm was fixed.

5.0.001 (2007-09-14)
	- hungarian language was added.
	- fixed require_once path on shared/code/tce_functions_errmsg.php.
	- fixed title on installation script.

5.0.000 (2007-08-28)
	- database schema is changed (see documentation on admin/doc/database).
	- new ordering type questions was added.
	- free answer questions may now be checked against alternative text answers (short answers).
	- the questions selection was fixed on test editor and test generators.
	- all answers of MCMA question may be false.
	- the offline PDF tests now contains the correct answers in hidden white color; to display the correct results:
		* from PDF viewer, go to "Accessibility" -> "Page Display preferences", check "Replace Document Colors", uncheck "Only change the color of black text or line art".

--------------------------------------------------------------------------------

4.2.003 (2007-08-14)
	- TCPDF library was updated.

4.2.002 (2007-05-21)
	- An improvement on questions selection was added.

4.2.001 (2007-05-19)
	- The bit depth of LaTeX images was forced to 8 bit to avoid incompatibility with TCPDF.

4.2.000 (2007-05-18)
	- LaTeX support was added (read: /install/README_LATEX.TXT)

4.1.000 (2007-04-30)
	- Some severe security vulnerabilities were fixed (please update also configuration files).
	- Group filter was added on test results.
	- Test end time and test duration were added on user's results.
	- Answer statistics were added on "statistics".

4.0.011 (2007-04-05)
	- K_TIMEZONE constant was added to shared/config/tce_config.php to simplify the timezone settings.
	- shared/code/tce_db_dal_mysql.php was updated.

4.0.010 (2007-03-20)
	- tcpdf library were updated. Now you may search and copy unicode text from PDF documents.
	- language selector were added.
	- a bug on user XML export were fixed.

4.0.009 (2007-03-06)
	- tcpdf were updated.
	- DejaVu fonts for TCPDF were added.

4.0.008 (2007-02-14)
	- duplicate answers bug for MCMA questions on PDF test were fixed.

4.0.007 (2007-02-12)
	- shared/code/tce_functions_form.php were updated.
	- vietnamese language were added.

4.0.006 (2006-12-15)
	- Minor bugfixing on /admin/code/tce_edit_test.php.
	- TCPDF were updated.

4.0.005 (2006-11-24)
	- Third party applications phpMyAdmin and phpPgAmin were removed from TCExam distribution.
	- Installation instructions and documentation were updated.

4.0.004 (2006-11-20)
	- Brazilian Portuguese and Turkish language were added.
	- alt attribute were added for images/objects.
	- questions are now copied when a new test is created from an existing one.
	- documentation were updated.

4.0.003 (2006-11-10)
	- CSS files were fixed for IE7.

4.0.002 (2006-11-08)
	- two unreported bugs were fixed on:
		shared/code/tce_functions_test.php
		public/code/tce_test_execute.php

4.0.001 (2006-10-27)
	- TCPDF library were updated to version 1.53.TC025.
	- phpMyAdmin were updated to version 2.9.0.2.

4.0.000 (2006-10-01)
	- database schema is changed and it's not back-compatible.
	- database charset encodings were fixed to UTF8 UNICODE.
	- "safe_mode = On" and other php.ini security settings are not more required.
	- score percentages are now displayed on results.
	- a "terminate test" button were added to submit a test before the end of the available time.
	- tcpdf library were updated.
	- XML user importer may now be used to update users' data.
	- users may belong to none, one, or many groups.
	- tests may be assigned to one or many users' groups.
	- form functions were fixed.
	- information for translators were added on TRANSLATORS.TXT file.
	- utf-8 charset for MySQL database were fixed.
	- users' may now leave a comment on test.
	- phpMyAdmin and phpPgAdmin were updated.

--------------------------------------------------------------------------------

3.0.022 (2006-09-14)
	- An SQL bug on test execution were fixed.

3.0.021 (2006-09-05)
	- You cannot create a user with a level higher than yours.

3.0.020 (2006-07-01)
	- TCDPF library were updated.

3.0.019 (2006-06-26)
	- fixed sql error introduced with latest version.

3.0.018 (2006-06-26)
	- some bugs on test generation were fixed.
	- lock/unlock button were added on Test Results Summary (/admin/code/tce_show_result_allusers.php).

3.0.017 (2006-06-21)
	- CSS files were updated.
	- code preview bug were fixed.

3.0.016 (2006-06-20)
	- /shared/jscript/inserttag.js were updated.
	- files path for [object] were fixed.
	- mime types were updated on /shared/config/tce_mime.php.
	- accessibility and usability were improved.
	- spanish translation by Carlos Alarcon were introduced.
	- test time extender button and lock/unlock button were added on user's results page.

3.0.015 (2006-06-03)
	- TMX-PHP bridge were updated.

3.0.014 (2006-06-02)
	- TCExam logo were changed.
	- phpMyAdmin were updated.
	- documentation were updated.

3.0.013 (2006-05-23)
	- page selection bug on questions list were fixed.

3.0.012 (2006-05-21)
	- tmx language file were updated.
	- CSS files were updated.
	- tcpdf were updated.
	- public interface is now independent from javascript.
	- admin interfaces now works also without javascript.

3.0.011 (2006-05-18)
	- fixed font names.

3.0.010 (2006-05-18)
	- TCPDF library were updated.
	- New PDF default fonts were installed.

3.0.009 (2006-05-15)
	- A bug on test editor were fixed.

3.0.008 (2006-05-13)
	- Accessibility were deeply improved for visually impaired users.

3.0.007 (2006-05-10)
	- configuration file for phpMyAdmin were fixed (/admin/phpMyAdmin/config.inc.php).

3.0.006 (2006-04-21)
	- phpMyAdmin were updated.
	- documentation and installation instructions were updated.
	- the admin menu now displays either phpMyAdmin or PhpPgAdmin by case.

3.0.005 (2006-04-15)
	- a bug related to time formatting when using MySQL database were fixed.
	- CSS files were updated.

3.0.004 (2006-04-15)
	- a bug regarding the order of answers were fixed.

3.0.003 (2006-04-14)
	- a bug regarding questions selection were fixed.

3.0.002 (2006-04-07)
	- minor improvements.
	- CSS code were cleaned.

3.0.001 (2006-04-01)
	- a new field 'logansw_order' has been introduced on 'tce_tests_logs_answers' table to fix the sorting BUG.

3.0.000 (2006-03-31)
	- this release contains new features and improvements.
	- database schema and configuration files were changed.
	- multiple answers on multiple-choiche questions are now supported.
	- users' groups were supported.
	- new scoring system were introduced.
	- pages now conforms to "DTD XHTML 1.0 Strict".
	- tcpdf class were updated to latest version.
	- TMXResourceBundle class were updated to latest version.
	- documentation were updated.
	- accessibility were improved.
	- questions can be exported and imported via XML files.
	- users and groups can be exported and imported via XML or TSV files.
	- a chaching mechanism has been introduced to speed up the loading of TMX language files.
	- users results can be exported in TSV file format (tab delimited text).

--------------------------------------------------------------------------------

2.0.022 (2006-02-07)
	- first Open Source release.

2.0.021 (2006-01-18)
	- phpMailer were updated.

2.0.020 (2006-01-01)
	- fixed session/authentication bug.
	- phpMyAdmin were updated.
	- phpPgAdmin were updated.

2.0.019 (2005-08-07)
	- TMX logo were removed.

2.0.018 (2005-07-07)
	- the ebable/disable mechanism for topics, questions and answers were improved.
	- Question List were added.
	- the documentation were updated.
	- minor bugs were fixed.

2.0.017 (2005-07-04)
	- new licenses were added.

2.0.016 (2005-07-02)
	- all interfaces were tested and cleaned to comply with XHTML AND W3C-WAI specifications.

2.0.015 (2005-06-27)
	- XHTML warnings were fixed.

2.0.014 (2005-05-29)
	- automatic logout at test ending were added.
	- some PDF issues were fixed.

2.0.013 (2005-04-30)
	- fixed time visualization on question statistics.

2.0.012 (2005-04-30)
	- the "no answer" as alternative answer could be disabled.
	- fixed client countdown timer .

2.0.011 (2005-04-27)
	- fixed user result void view.

2.0.010 (2005-04-23)
	- fixed user statistic selection.

2.0.009 (2005-04-23)
	- fixed user statistic selection.

2.0.008 (2005-04-23)
	- fixed login issue.

2.0.007 (2005-04-07)
	- fixed checkbox bug on postgresql.
	- fixed authentication bug for old browsers.

2.0.006 (2005-03-31)
	- TCPDF library were updated.

2.0.005 (2005-03-23)
	- TCPDF library were updated.

2.0.004 (2005-03-04)
	- multimedia files support were added.

2.0.003 (2005-02-26)
	- email support were added.

2.0.002 (2005-02-23)
	- TMX logo on about page were added.

2.0.001 (2005-02-21)
	- minor bug fixing and improvements.

2.0.000 (2005-01-10)
	- new major release.
	- require PHP5, MySQL 4.1 or PostgreSQL 7.4.

--------------------------------------------------------------------------------

1.0.004 (2004-08-10)
	- documentation were updated.

1.0.003 (2004-07-18)
	- the english language were added.

1.0.002 (2004-07-15)
	- xhtml to PDF conversion where improved.

1.0.001 (2004-07-14)
	- xhtml to pdf conversion were fixed.
	- phpMyAdmin were updated to 2.5.7.

1.0.000 (2004-04-17)
	- first stable release.

--------------------------------------------------------------------------------
